--[[ Info

"Copyright": Destructive Reality

Unbefugte nderungen am Quellcode sind nicht gestattet!


Code by: Bastian Hodapp, Simon Schneider


--]]


--"Addons"
	
	hump = {}

	hump.class = require ("Libraries.class")

	hump.vector= require ("Libraries.vector")

	hump.camera = require ("Libraries.camera")

	local gwee = require ("Libraries.gwee")

	require ("Libraries.slither")

	require ("Libraries.LUBE")


function love.load()

	
	--Allerlei Variablen ^^
		cursorVisible = false
		gameState = "mainMenu"
		
		--[[
			Gamestates:
			mainMenu = Hauptmen
			game = Im Spiel
			optionsMenu = Optionsmen
			graphicOptions = Grafikoptionen
			network = Netzwerkmen/Multiplayer
		
		
		--]]
	
	--Charaktervariablen
		health = 3
		maxHealth = 3
		minHealth = 0
	
	--Bewegungsvariablen
		turnSpeed = 2.5
		moveSpeed = 30
		normalSpeed = 30
		
		maxAcceleration = 200
		
	--Schussvariablen
		bulletSpeed = 800
		munition = 10
		maxMunition = 10
		
	--Hintergrundfarbe
		love.graphics.setBackgroundColor(0, 0, 0)
	
	
	--GUI		 
		--Debugmen
			debugMenuVisible = true
		
			debugMenu = gwee.Group(gwee.Box(100, 30, 160, 120), gwee.VerticalLayout(5),"Debug-Men")
			debugMenu:add(gwee.Button(function() love.graphics.setMode(800, 600) end, "800x600"))
			debugMenu:add(gwee.Button(function() love.graphics.setMode(1366, 768, true) end, "Fullscreen"))
			debugMenu:add(gwee.Button(function() health = health + 1 end, "Leben +1"))
			debugMenu:add(gwee.Button(function() health = health - 1 end, "Leben -1"))
			debugMenu:add(gwee.Button(function() gameState = "mainMenu" end, "Zurck zum Hauptmen"))
			
			debugMenu.enabled = false
			
			
		--Hauptmen
			mainMenu = gwee.Group(gwee.Box(100, 150, 100, 90), gwee.VerticalLayout(5),"Hauptmen")
			mainMenu:add(gwee.Button(function() gameState = "game" end, "Testspiel"))
			mainMenu:add(gwee.Button(function() gameState = "network" end, "Multiplayer"))
			mainMenu:add(gwee.Button(function() gameState = "optionsMenu" end, "Optionen"))
			mainMenu:add(gwee.Button(function() love.event.push('q') end, "Schlieen"))
			
			
			
		--Optionsmen
			optionsMenu = gwee.Group(gwee.Box(100, 150, 180, 60), gwee.VerticalLayout(5),"Optionen")
			optionsMenu:add(gwee.Button(function() gameState = "graphicOptions" end, "Grafikeinstellungen"))
			optionsMenu:add(gwee.Button(function() gameState = "mainMenu" end, "Zurck zum Hauptmen"))
			
			optionsMenu.enabled = false
			
		--Grafikmen
			graphicOptions = gwee.Group(gwee.Box(100, 150, 140, 100), gwee.VerticalLayout(5),"Grafikeinstellungen")
			graphicOptions:add(gwee.Button(function() love.graphics.setMode(800, 600) end, "800x600"))
			graphicOptions:add(gwee.Button(function() love.graphics.setMode(1366, 768, true) end, "Fullscreen(1366x768)"))
			graphicOptions:add(gwee.Button(function() love.graphics.setMode(1920, 1080, true) end, "Fullscreen(1920x1080)"))
			graphicOptions:add(gwee.Button(function() gameState = "optionsMenu" end, "Zurck"))			
			
			graphicOptions.enabled = false
			
			
		--Netzwerkmen
			networkMenu = gwee.Group(gwee.Box(400, 300, 100, 70), gwee.VerticalLayout(5),"Netzwerkverbindungen:")
			isServer = networkMenu:add(gwee.CheckBox("Server (Wenn ja, dann Server, wenn Nein, dan Client:"))
			connectIP = networkMenu:add(gwee.TextField("IP:"))
			networkMenu:add(gwee.Button(function() gameState = "mainMenu" end, "Zurck zum Hauptmen"))
		
			networkMenu.enabled = false
		
		
		love.mouse.setVisible(cursorVisible)
		
	--Netzwerk/Multiplayer
		isServer = true
		port = 55655
		connectIP = "0.0.0.0"
		ownIP = 0

		server = lube.Server
		
		
		client = lube.Client
		
			lube.Client.init()
			lube.Client.setHandshake("Hi!") --this is a unique string that will be sent when connecting and disconnecting
			lube.Client.setCallback(rcvCallback) --set rcvCallback as the callback for received messages
			lube.Client.connect(ip, port) --change ip and port into.. an ip and a port
		
		
		
		
	--Bilder
		tankBase = love.graphics.newImage("gfx/tanks/TankBase.png") --Panzerbasis
		tank = love.graphics.newImage("gfx/tanks/TankBase.png") --Gegner
		cannon = love.graphics.newImage("gfx/tanks/Cannon.png") --Panzerkanone
		bullet = love.graphics.newImage("gfx/bullets/Bullet.png") --Geschosskugel
		heart = love.graphics.newImage("gfx/gui/heart.png") --Herz(Lebensanzeige)
		fadenkreuz = love.graphics.newImage("gfx/gui/fadenkreuz.png") --Fadenkreuz
	
	--Nichts ndern!
		acceleration = 0.5
		tankx = 400
		tanky = 300
		tankAngle = 0
		cannonRotation = -(math.atan2((tankx-love.mouse.getX()),(tanky-love.mouse.getY())))
	
		FPS = love.timer.getFPS()
		screenwidth = love.graphics.getWidth()
		screenheight = love.graphics.getHeight()
		mouseX = love.mouse.getX()
		mouseY = love.mouse.getY()
		
		spawn = false
		
	--Schieen
		bullets = {}
		magazine = 10
		magazinValue = 10
		
	--Enemies
		enemies = {}
		
		
	
	
end

function love.draw()
	
	gwee.draw()
	
	
	--Fadenkreuz
		love.graphics.draw(fadenkreuz, mouseX, mouseY, 0, 0.75, 0.75, 16, 16)
		
		
	if gameState == "mainMenu" then
		
		mainMenu.enabled = true
		
	else
	
		mainMenu.enabled = false
	
	end
	
	
	if gameState == "game" then
	
		--Leben
			if health == 3 then
			
			love.graphics.draw(heart, 0, 0, 0, 0.25, 0.25, 0, 0 )
			love.graphics.draw(heart, 32, 0, 0, 0.25, 0.25, 0, 0 )
			love.graphics.draw(heart, 64, 0, 0, 0.25, 0.25, 0, 0 )
				
			end	
			
			if health == 2 then
			
			love.graphics.draw(heart, 0, 0, 0, 0.25, 0.25, 0, 0 )
			love.graphics.draw(heart, 32, 0, 0, 0.25, 0.25, 0, 0 )
				
			end	
			
			if health == 1 then
			
			love.graphics.draw(heart, 0, 0, 0, 0.25, 0.25, 0, 0 )
			
			end	
			
			
		
		love.graphics.draw(tankBase, tankx, tanky, tankAngle - 1.568, 1, 1, 32, 32)
		love.graphics.draw(cannon, tankx, tanky, cannonRotation, 1, 1, 32, 32)
		
		
		if debugMenuVisible == true then

			love.graphics.print(tankAngle, 50,50)
			love.graphics.print(tankx, 50,70)
			love.graphics.print(tanky, 50,90)
			love.graphics.print(munition, 50,110)
			love.graphics.print(magazine, 50, 130)
			love.graphics.print(moveSpeed, 50, 150)
		end
			
		
		--Bullet
			for i,v in ipairs(bullets) do
				
				love.graphics.draw(bullet, v["x"], v["y"], v["r"], 3, 3)
				
				
			end
			
		--Enemies
			
			for i,v in ipairs(enemies) do
				
					love.graphics.draw(tank, v["x"], v["y"], 0, 1,1,32,32)
					
			end
			
			
			if spawn == true then
				for i,v in ipairs(enemies) do
				
					love.graphics.draw(tank, v["x"], v["y"], 0, 1,1,32,32)
					
				end
									
					spawn = false
			end
			
		end
	
end

function love.update(dt)
	
	gwee.update(dt)
	
	--Variablenaktualisierung
		screenwidth = love.graphics.getWidth()
		screenheight = love.graphics.getHeight()
		mouseX = love.mouse.getX()
		mouseY = love.mouse.getY()
		if health > maxHealth then health = maxHealth end
		if health < minHealth then health = minHealth end
		
		love.graphics.setScissor( 0, 0, screenwidth, screenheight )
		
		
	if gameState == "mainMenu" then
		
		mainMenu.enabled = true		
		
		
	else
	
		mainMenu.enabled = false
	
	end
	
	
	if gameState == "optionsMenu" then
		
		optionsMenu.enabled = true		
		
		
	else
	
		optionsMenu.enabled = false
	
	end
	
	
	if gameState == "graphicOptions" then
		
		graphicOptions.enabled = true		
		
		
	else
	
		graphicOptions.enabled = false
	
	end
	
	
	
	if gameState == "network" then
		
		networkMenu.enabled = true		
		
		
	else
	
		networkMenu.enabled = false
	
	end
	
	
	if gameState == "game" then

		--GUI
			
			 
				if debugMenuVisible == true then

					debugMenu.enabled = true
				
				elseif debugMenuVisible == false then

					debugMenu.enabled = false
				
				end
		
		--Munition
			if love.keyboard.isDown("r") and magazine > 0 and munition == 0 then
				reload()
				magazine = magazine - 1
			end
		
		--Bewegung(Rotation)
			cannonRotation = -(math.atan2((tankx-love.mouse.getX()),(tanky-love.mouse.getY())))
		
			if love.keyboard.isDown("a") then tankAngle = tankAngle - (dt * turnSpeed)
			elseif love.keyboard.isDown("d") then tankAngle = tankAngle + (dt * turnSpeed) end
			
		--Bewegung(Fahren)	
			if love.keyboard.isDown("w") then
				tankx = tankx - (math.cos(tankAngle) * moveSpeed * dt)
				tanky = tanky -(math.sin(tankAngle) * moveSpeed * dt)
				if maxAcceleration > moveSpeed then moveSpeed = moveSpeed + acceleration end --Beschleunigung				
			
			elseif love.keyboard.isDown("s") then
				
				tankx = tankx + (math.cos(tankAngle) * moveSpeed * dt)
				tanky = tanky + (math.sin(tankAngle) * moveSpeed * dt)
				if maxAcceleration > moveSpeed then moveSpeed = moveSpeed + acceleration end --Beschleunigung
			else
			
				moveSpeed = normalSpeed --Beschleunigung zurcksetzen
				
			end
			
		--Schieen
			for i,v in ipairs(bullets) do
				v["x"] = v["x"] + (v["dx"] * dt)
				v["y"] = v["y"] + (v["dy"] * dt)
			end
			
		--Enemies
			if love.keyboard.isDown("lctrl") and love.mouse.isDown("l") and spawn == true then
				
				table.insert(enemies, {x = mouseX, y = mouseY})
				
				spawn = true
				
				
			end
		
		else
		
			debugMenu.enabled = false
		
		end		
			
end

function love.mousepressed(x, y, button)
	gwee.mousepressed(x, y, button)
	if button == "l" and munition > 0  then
		local startX = tankx
        local startY = tanky
        local mouseX = x
        local mouseY = y
       
        local angle = math.atan2((mouseY - startY), (mouseX - startX))
       
        local bulletDx = bulletSpeed * math.cos(angle)
        local bulletDy = bulletSpeed * math.sin(angle)
       
        table.insert(bullets, {x = startX, y = startY, dx = bulletDx, dy = bulletDy, r = cannonRotation})
		
		munition = munition - 1
		
    end

end

function love.mousereleased(x, y, button)
    gwee.mousereleased(x, y, button)
end

function love.keypressed(key, unicode)
    gwee.keypressed(key, unicode)			
end


function reload ()
	
	munition = magazinValue

end

function rcvCallback(data)
    
	
	
end